(cl:defpackage :std.regex
  (:use)
  (:local-nicknames (:% :std.internal)))
(cl:in-package :std.regex)

(%:fn/macro compile (regex :key ((destructive destructive?)) ((extended-mode extended?)) ((single-line-mode single-line?)) ((multi-line-mode multi-line?)) ((case-insensitive-mode case-insensitive?))) cl-ppcre:create-scanner)
(%:fn/macro compile-optimized-test-function ((test-function function) :key (start 0) (end cl-ppcre:*regex-char-code-limit*) (kind cl-ppcre:*optimize-char-classes*)) cl-ppcre:create-optimized-test-function)
(%:fn/macro replace ((target-string string) regex  (replacement new) :key (start 0) (end (cl:length string)) ((preserve-case preserve-case?)) simple-calls ((element-type type) 'cl:character)) cl-ppcre:regex-replace)
(%:fn/macro replace-all ((target-string string) regex (replacement new) :key (start 0) (end (cl:length string)) ((preserve-case preserve-case?)) simple-calls ((element-type type) 'cl:character)) cl-ppcre:regex-replace-all)
(%:fn/macro split ((target-string string) regex :key (start 0) (end (cl:length string)) ((limit max)) ((with-registers-p with-register?)) ((omit-unmatched-p ignore-unmatched?)) ((sharedp shared?))) cl-ppcre:split)
(%:fn/macro find ((target-string string) regex :key real-start-pos (start 0) (end (cl:length string))) cl-ppcre:scan)
(%:fn/macro find-collect ((target-string string) regex :key (start 0) (end (cl:length string)) ((sharedp shared?))) cl-ppcre:scan-to-strings)
(%:fn/macro match-positions ((target-string string) regex :key (start 0) (end (cl:length string))) cl-ppcre:all-matches)
(%:fn/macro match-strings ((target-string string) regex :key (start 0) (end (cl:length string)) ((sharedp shared?))) cl-ppcre:all-matches-as-strings)
(%:fn/macro quote-meta-chars (string :key (start 0) (end (cl:length string)) ((sharedp shared?))) cl-ppcre:quote-meta-chars)
